#include "syscall.hpp"
#include "termdev.hpp"
#include "mmngr.hpp"
#include "io.hpp"
#include "pcdevice.hpp"
#include "deviceproc.hpp"

void* sysCalls[] =
{
	_usleep, kmalloc, kfree, getDev, 0, 0, write, read, getDevFile
};
/*
Parameters are being passed by registers in following order:
EBX being the first paramater,
ECX the second,
and so on for the EDX, EDI and ESI.
*/
const size_t maxSysCall = sizeof(sysCalls)/sizeof(unsigned)-1;
_declspec(naked) void sysCallIntHandler()
{
	_asm
	{
		push esi
		push edi
		push edx
		push ecx
		push ebx
		cmp eax, [maxSysCall]
		jg goaw
		lea eax, [sysCalls+eax*4]
		call [eax]
		add esp, 20
		goaw:iretd
	}
}
